git-am.sh 11.1 KB
Newer Older
1 2
#!/bin/sh
#
3
# Copyright (c) 2005, 2006 Junio C Hamano
4

5
USAGE='[--signoff] [--dotest=<dir>] [--utf8 | --no-utf8] [--binary] [--3way]
6
  [--interactive] [--whitespace=<option>] <mbox>...
7 8
  or, when resuming [--skip | --resolved]'
. git-sh-setup
9
set_reflog_action am
10
require_work_tree
11

12 13
git var GIT_COMMITTER_IDENT >/dev/null || exit

14 15 16 17 18
stop_here () {
    echo "$1" >"$dotest/next"
    exit 1
}

19
stop_here_user_resolve () {
20 21 22 23
    if [ -n "$resolvemsg" ]; then
	    echo "$resolvemsg"
	    stop_here $1
    fi
24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42
    cmdline=$(basename $0)
    if test '' != "$interactive"
    then
        cmdline="$cmdline -i"
    fi
    if test '' != "$threeway"
    then
        cmdline="$cmdline -3"
    fi
    if test '.dotest' != "$dotest"
    then
        cmdline="$cmdline -d=$dotest"
    fi
    echo "When you have resolved this problem run \"$cmdline --resolved\"."
    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."

    stop_here $1
}

43 44 45 46 47 48 49
go_next () {
	rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
		"$dotest/patch" "$dotest/info"
	echo "$next" >"$dotest/next"
	this=$next
}

50 51 52 53 54 55
cannot_fallback () {
	echo "$1"
	echo "Cannot fall back to three-way merge."
	exit 1
}

56 57 58 59 60 61 62
fall_back_3way () {
    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`

    rm -fr "$dotest"/patch-merge-*
    mkdir "$dotest/patch-merge-tmp-dir"

    # First see if the patch records the index info that we can use.
63 64 65 66 67 68 69 70 71 72
    git-apply -z --index-info "$dotest/patch" \
	>"$dotest/patch-merge-index-info" &&
    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
    git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
    git-write-tree >"$dotest/patch-merge-base+" ||
    cannot_fallback "Patch does not record usable index information."

    echo Using index info to reconstruct a base tree...
    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
J
Junio C Hamano 已提交
73
	git-apply $binary --cached <"$dotest/patch"
74 75 76
    then
	mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
	mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
77 78 79
    else
        cannot_fallback "Did you hand edit your patch?
It does not apply to blobs recorded in its index."
80 81 82 83 84 85 86 87 88 89 90 91
    fi

    test -f "$dotest/patch-merge-index" &&
    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
    orig_tree=$(cat "$dotest/patch-merge-base") &&
    rm -fr "$dotest"/patch-merge-* || exit 1

    echo Falling back to patching base and 3-way merge...

    # This is not so wrong.  Depending on which base we picked,
    # orig_tree may be wildly different from ours, but his_tree
    # has the same set of wildly different changes in parts the
92
    # patch did not touch, so recursive ends up canceling them,
93 94
    # saying that we reverted all those changes.

95 96 97
    eval GITHEAD_$his_tree='"$SUBJECT"'
    export GITHEAD_$his_tree
    git-merge-recursive $orig_tree -- HEAD $his_tree || {
98 99 100 101
	    if test -d "$GIT_DIR/rr-cache"
	    then
		git-rerere
	    fi
102 103 104
	    echo Failed to merge in the changes.
	    exit 1
    }
105
    unset GITHEAD_$his_tree
106 107 108
}

prec=4
109
dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary= ws= resolvemsg=
110 111 112 113 114

while case "$#" in 0) break;; esac
do
	case "$1" in
	-d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
D
Dennis Stosberg 已提交
115
	dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
116 117 118 119 120 121 122 123
	-d|--d|--do|--dot|--dote|--dotes|--dotest)
	case "$#" in 1) usage ;; esac; shift
	dotest="$1"; shift;;

	-i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
	--interacti|--interactiv|--interactive)
	interactive=t; shift ;;

124 125 126
	-b|--b|--bi|--bin|--bina|--binar|--binary)
	binary=t; shift ;;

127 128 129 130 131
	-3|--3|--3w|--3wa|--3way)
	threeway=t; shift ;;
	-s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
	sign=t; shift ;;
	-u|--u|--ut|--utf|--utf8)
132
	utf8=t; shift ;; # this is now default
133 134
	--no-u|--no-ut|--no-utf|--no-utf8)
	utf8=; shift ;;
135 136 137
	-k|--k|--ke|--kee|--keep)
	keep=t; shift ;;

J
Junio C Hamano 已提交
138 139 140
	-r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
	resolved=t; shift ;;

141 142 143
	--sk|--ski|--skip)
	skip=t; shift ;;

J
Junio C Hamano 已提交
144 145 146
	--whitespace=*)
	ws=$1; shift ;;

147 148 149
	--resolvemsg=*)
	resolvemsg=$(echo "$1" | sed -e "s/^--resolvemsg=//"); shift ;;

150 151 152 153 154 155 156 157 158
	--)
	shift; break ;;
	-*)
	usage ;;
	*)
	break ;;
	esac
done

J
Junio C Hamano 已提交
159 160
# If the dotest directory exists, but we have finished applying all the
# patches in them, clear it out.
161 162 163 164 165 166 167 168 169 170 171
if test -d "$dotest" &&
   last=$(cat "$dotest/last") &&
   next=$(cat "$dotest/next") &&
   test $# != 0 &&
   test "$next" -gt "$last"
then
   rm -fr "$dotest"
fi

if test -d "$dotest"
then
J
Junio C Hamano 已提交
172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190
	case "$#,$skip$resolved" in
	0,*t*)
		# Explicit resume command and we do not have file, so
		# we are happy.
		: ;;
	0,)
		# No file input but without resume parameters; catch
		# user error to feed us a patch from standard input
		# when there is already .dotest.  This is somewhat
		# unreliable -- stdin could be /dev/null for example
		# and the caller did not intend to feed us a patch but
		# wanted to continue unattended.
		tty -s
		;;
	*)
		false
		;;
	esac ||
	die "previous dotest directory $dotest still exists but mbox given."
191
	resume=yes
192
else
J
Junio C Hamano 已提交
193 194
	# Make sure we are not given --skip nor --resolved
	test ",$skip,$resolved," = ,,, ||
195
		die "Resolve operation not in progress, we are not resuming."
196 197 198 199

	# Start afresh.
	mkdir -p "$dotest" || exit

200
	git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
201 202 203 204
		rm -fr "$dotest"
		exit 1
	}

J
Junio C Hamano 已提交
205 206
	# -b, -s, -u, -k and --whitespace flags are kept for the
	# resuming session after a patch failure.
J
Junio C Hamano 已提交
207
	# -3 and -i can and must be given when resuming.
208
	echo "$binary" >"$dotest/binary"
J
Junio C Hamano 已提交
209
	echo " $ws" >"$dotest/whitespace"
210 211 212 213 214 215
	echo "$sign" >"$dotest/sign"
	echo "$utf8" >"$dotest/utf8"
	echo "$keep" >"$dotest/keep"
	echo 1 >"$dotest/next"
fi

J
Junio C Hamano 已提交
216 217 218 219 220 221 222 223 224
case "$resolved" in
'')
	files=$(git-diff-index --cached --name-only HEAD) || exit
	if [ "$files" ]; then
	   echo "Dirty index: cannot apply patches (dirty: $files)" >&2
	   exit 1
	fi
esac

225 226 227 228
if test "$(cat "$dotest/binary")" = t
then
	binary=--allow-binary-replacement
fi
229 230 231
if test "$(cat "$dotest/utf8")" = t
then
	utf8=-u
232 233
else
	utf8=-n
234 235 236 237 238
fi
if test "$(cat "$dotest/keep")" = t
then
	keep=-k
fi
J
Junio C Hamano 已提交
239
ws=`cat "$dotest/whitespace"`
240 241 242 243 244 245 246 247 248 249 250 251 252 253
if test "$(cat "$dotest/sign")" = t
then
	SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
			s/>.*/>/
			s/^/Signed-off-by: /'
		`
else
	SIGNOFF=
fi

last=`cat "$dotest/last"`
this=`cat "$dotest/next"`
if test "$skip" = t
then
254 255 256 257
	if test -d "$GIT_DIR/rr-cache"
	then
		git-rerere clear
	fi
258
	this=`expr "$this" + 1`
J
Jan Harkes 已提交
259
	resume=
260 261 262 263 264 265 266 267 268 269 270 271 272 273
fi

if test "$this" -gt "$last"
then
	echo Nothing to do.
	rm -fr "$dotest"
	exit
fi

while test "$this" -le "$last"
do
	msgnum=`printf "%0${prec}d" $this`
	next=`expr "$this" + 1`
	test -f "$dotest/$msgnum" || {
J
Jan Harkes 已提交
274
		resume=
275 276 277
		go_next
		continue
	}
J
Junio C Hamano 已提交
278 279 280 281 282 283 284 285 286

	# If we are not resuming, parse and extract the patch information
	# into separate files:
	#  - info records the authorship and title
	#  - msg is the rest of commit log message
	#  - patch is the patch body.
	#
	# When we are resuming, these files are either already prepared
	# by the user, or the user can tell us to do so by --resolved flag.
287 288 289 290 291 292 293 294
	case "$resume" in
	'')
		git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
			<"$dotest/$msgnum" >"$dotest/info" ||
			stop_here $this
		git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
		;;
	esac
295 296 297 298

	GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
	GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
	GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
299 300 301 302 303 304 305

	if test -z "$GIT_AUTHOR_EMAIL"
	then
		echo "Patch does not have a valid e-mail address."
		stop_here $this
	fi

J
Junio C Hamano 已提交
306
	export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
307

308
	SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
309
	case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
310 311 312 313 314

	case "$resume" in
	'')
	    if test '' != "$SIGNOFF"
	    then
315
		LAST_SIGNED_OFF_BY=`
316 317 318
		    sed -ne '/^Signed-off-by: /p' \
		    "$dotest/msg-clean" |
		    tail -n 1
319
		`
320 321
		ADD_SIGNOFF=`
		    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
322 323
		    test '' = "$LAST_SIGNED_OFF_BY" && echo
		    echo "$SIGNOFF"
324 325
		}`
	    else
326
		ADD_SIGNOFF=
327 328
	    fi
	    {
329 330 331 332 333 334 335 336 337 338
		echo "$SUBJECT"
		if test -s "$dotest/msg-clean"
		then
			echo
			cat "$dotest/msg-clean"
		fi
		if test '' != "$ADD_SIGNOFF"
		then
			echo "$ADD_SIGNOFF"
		fi
339 340
	    } >"$dotest/final-commit"
	    ;;
J
Junio C Hamano 已提交
341
	*)
342
		case "$resolved$interactive" in
J
Junio C Hamano 已提交
343 344 345 346 347
		tt)
			# This is used only for interactive view option.
			git-diff-index -p --cached HEAD >"$dotest/patch"
			;;
		esac
348
	esac
349

350
	resume=
351 352
	if test "$interactive" = t
	then
353 354
	    test -t 0 ||
	    die "cannot be interactive without stdin connected to a terminal."
355 356 357 358 359 360 361
	    action=again
	    while test "$action" = again
	    do
		echo "Commit Body is:"
		echo "--------------------------"
		cat "$dotest/final-commit"
		echo "--------------------------"
J
Jason Riedy 已提交
362
		printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
363 364
		read reply
		case "$reply" in
365 366 367 368
		[yY]*) action=yes ;;
		[aA]*) action=yes interactive= ;;
		[nN]*) action=skip ;;
		[eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
369
		       action=again ;;
370 371 372
		[vV]*) action=again
		       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
		*)     action=again ;;
373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394
		esac
	    done
	else
	    action=yes
	fi

	if test $action = skip
	then
		go_next
		continue
	fi

	if test -x "$GIT_DIR"/hooks/applypatch-msg
	then
		"$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
		stop_here $this
	fi

	echo
	echo "Applying '$SUBJECT'"
	echo

J
Junio C Hamano 已提交
395 396
	case "$resolved" in
	'')
J
Junio C Hamano 已提交
397
		git-apply $binary --index $ws "$dotest/patch"
J
Junio C Hamano 已提交
398 399 400 401 402 403 404 405
		apply_status=$?
		;;
	t)
		# Resolved means the user did all the hard work, and
		# we do not have to do any patch application.  Just
		# trust what the user has in the index file and the
		# working tree.
		resolved=
406 407 408
		changed="$(git-diff-index --cached --name-only HEAD)"
		if test '' = "$changed"
		then
409
			echo "No changes - did you forget to use 'git add'?"
410
			stop_here_user_resolve $this
411
		fi
412 413 414 415
		unmerged=$(git-ls-files -u)
		if test -n "$unmerged"
		then
			echo "You still have unmerged paths in your index"
416
			echo "did you forget to use 'git add'?"
417
			stop_here_user_resolve $this
418
		fi
J
Junio C Hamano 已提交
419
		apply_status=0
420 421 422 423
		if test -d "$GIT_DIR/rr-cache"
		then
			git rerere
		fi
J
Junio C Hamano 已提交
424 425 426
		;;
	esac

427 428
	if test $apply_status = 1 && test "$threeway" = t
	then
429
		if (fall_back_3way)
430
		then
431 432
		    # Applying the patch to an earlier tree and merging the
		    # result may have produced the same tree as ours.
433
		    changed="$(git-diff-index --cached --name-only HEAD)"
434 435 436 437 438 439 440 441
		    if test '' = "$changed"
		    then
			    echo No changes -- Patch already applied.
			    go_next
			    continue
		    fi
		    # clear apply_status -- we have successfully merged.
		    apply_status=0
442 443 444 445 446
		fi
	fi
	if test $apply_status != 0
	then
		echo Patch failed at $msgnum.
447
		stop_here_user_resolve $this
448 449 450 451 452 453 454 455 456 457 458 459
	fi

	if test -x "$GIT_DIR"/hooks/pre-applypatch
	then
		"$GIT_DIR"/hooks/pre-applypatch || stop_here $this
	fi

	tree=$(git-write-tree) &&
	echo Wrote tree $tree &&
	parent=$(git-rev-parse --verify HEAD) &&
	commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
	echo Committed: $commit &&
460
	git-update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
461 462 463 464 465 466 467 468 469 470 471
	stop_here $this

	if test -x "$GIT_DIR"/hooks/post-applypatch
	then
		"$GIT_DIR"/hooks/post-applypatch
	fi

	go_next
done

rm -fr "$dotest"